'''
This code approximates the MDP policy/values in Figure 21.1.

@author: kvlinden
@version 25april2013
'''

from aima.utils import print_table
from klebanoff.passive_adp import GridMDP, PassiveADPAgent
    
# Define the standard Gridworld example.
grid = GridMDP([[-0.04, -0.04, -0.04, +1.0],
                [-0.04, None, -0.04, -1.0],
                [-0.04, -0.04, -0.04, -0.04]],
               terminals=[(3, 2), (3, 1)])
policy = [['>', '>', '>', '.'],
          ['^', None, '^', '.'],
          ['^', '<', '<', '<']]
agent = PassiveADPAgent(grid, policy)

# Run the passive ADP learning algorithm with n set based on Figure 21.3.
for i in range (0, 10):
    agent.execute_trial()
    
# Print the policy and utility values.
print "Given the policy:"
print_table(grid.to_arrows(agent.policy))
print
print "Passive ADP learned these rewards:"
print_table(grid.to_grid(agent.utility))

